'use strict';

module.exports = {

  check(ok, ko) {
    return this.scmFetch()
      .then(ok, ko);
  },

  run(ok, ko) {
    const promises = [];
    const configMaster = this.semverGetVersionConfig();
    const masterVersion = configMaster ? configMaster.initialVersion : undefined;
    Object.getOwnPropertyNames(this.params.gitflowBase).forEach((branch) => {
      promises.push(this.execute(this.gitCmd, ['branch', branch])
        .catch((e) => this.logger.info('continue with execution!'))
        .then(() => this.execute(this.gitCmd, ['checkout', branch]))
        .then(() => this.execute(this.gitCmd, ['push', '--set-upstream', 'origin', branch]))
        .then(() => this.semverConfig(this.params.gitflowBase[branch], true, masterVersion))
        .then((config) => this.semverStrategy(config))
        .then((config) => this.semverSaveVersion(config))
      );
    });
    return Promise.all(promises)
      .then(() => this.execute(this.gitCmd, ['checkout', 'master']))
      .then(() => this.execute(this.gitCmd, ['push', '--all']))
      .then(ok, ko);
  }

};